﻿// -------------------------------------------------------
// Automatically generated with Kodeo's Reegenerator
// Generator: RgenTemplate (internal)
// Generation date: 2019-03-09 03:07
// Generated by: Christian-PC\Christian
//-------------------------------------------------------
namespace OneAccomplishment.CodeGen.Data.Essentials
{
    using OneAccomplishment.CodeGen.Renderers;
    
    
    [System.CodeDom.Compiler.GeneratedCodeAttribute("Reegenerator", "2.0.16.0")]
    [Kodeo.Reegenerator.Generators.TemplateDisplayAttribute(DisplayName=null, Description=null, HideInDialog=true)]
    public partial class ConfigurationsRenderer : NestedCodeRenderer
    {
        
        /// <summary>
        ///Renders the code as defined in the source script file.
        ///</summary>
        ///<returns></returns>
        public override Kodeo.Reegenerator.Generators.RenderResults Render()
        {
            this.Output.Write("namespace ");
            this.Output.Write( ServiceNamespace );
            this.Output.Write("\r\n{\r\n    public partial interface IConfigurationService\r\n    {\r\n    ");
  foreach (var config in ConfigValues) { 
            this.Output.Write("\r\n        /// <summary>\r\n        /// ");
            this.Output.Write( ConfigDescriptions[config.MemberName] );
            this.Output.Write("\r\n        /// </summary>\r\n        ");
            this.Output.Write( config.Type );
            this.Output.Write(" ");
            this.Output.Write( config.ValidMemberName );
            this.Output.Write(" { get; }\r\n    ");
  } 
            this.Output.Write("\r\n    }\r\n}\r\n\r\nnamespace ");
            this.Output.Write( ConfigNamespace );
            this.Output.Write("\r\n{\r\n    internal sealed partial class ConfigurationService : IConfigurationServi" +
                    "ce\r\n    {\r\n    ");
  foreach (var config in ConfigValues) { 
            this.Output.Write("\r\n        public ");
            this.Output.Write( config.Type );
            this.Output.Write(" ");
            this.Output.Write( config.ValidMemberName );
            this.Output.Write("\r\n        {\r\n            get { return (");
            this.Output.Write( config.Type );
            this.Output.Write(")this.configSource.Value.");
            this.Output.Write( config.ValidMemberName );
            this.Output.Write("; }\r\n        }\r\n    ");
  } 
            this.Output.Write("\r\n    }\r\n}");
            this.Output.WriteLine();
            return new Kodeo.Reegenerator.Generators.RenderResults(this.Output.ToString());
        }
    }
}
